# -*- coding: utf-8 -*-

'''
    Filmnet Add-on (C) 2017
    Credits to Exodus and Covenant; our thanks go to their creators

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

import urllib, urlparse, re

import requests

from resources.lib.modules import cleantitle
from resources.lib.modules import client
from resources.lib.modules import source_utils
from resources.lib.modules import dom_parser
from resources.lib.modules import dom_parser2


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['gamato3.com']
        self.base_link = 'http://gamato3.com/'
        self.search_link2 = 'search/{}/feed/rss2/'
        self.search_link = 'http://gamato3.com/?s={}'

    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            url = self.__search([localtitle] + source_utils.aliases_to_array(aliases), year)
            if not url and title != localtitle: url = self.__search([title] + source_utils.aliases_to_array(aliases),
                                                                    year)
            return url
        except BaseException:
            return

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            url = self.__search([localtvshowtitle] + source_utils.aliases_to_array(aliases), year)
            if not url and tvshowtitle != localtvshowtitle: url = self.__search(
                [tvshowtitle] + source_utils.aliases_to_array(aliases), year)
            return url
        except BaseException:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            if not url:
                return
            url = [{'url': url, 'season': season, 'episode': episode}]
            return url
        except BaseException:
            return

    def __search(self, titles, year):
        try:
            query = [self.search_link.format(urllib.quote_plus(cleantitle.getsearch(i + ' ' + year))) for i in titles]
            # query = [urlparse.urljoin(self.base_link, i) for i in query]
            t = [cleantitle.get(i) for i in set(titles) if i]

            for u in query:
                try:
                    r = requests.get(u).text
                    r = client.parseDOM(r, 'div', attrs={'id': r'post-\d+'})
                    for i in r:
                        r = dom_parser.parse_dom(i, 'h1')[0]
                        r = dom_parser.parse_dom(r, 'a')[0]
                        title = r.attrs['title']
                        tit = re.sub(r'(\.|\(|\[|\s)(\d{4}|S\d+E\d+|S\d+|3D)(\.|\)|\]|\s|)(.+|)', '', title, re.I)
                        if cleantitle.get(tit) not in t:
                            continue
                        y = re.findall(r'(\d{4})', title, re.DOTALL)[0]
                        if year == y:
                            # print r.attrs['href']
                            return r.attrs['href']
                except BaseException:
                    pass
            return
        except BaseException:
            return

    def sources(self, url, hostDict, hostprDict):
        sources = []

        try:
            if not url:
                return sources

            if type(url) is list:
                url = url[0]
                query, season, episode = url['url'], url['season'], url['episode']
                # query = urlparse.urljoin(self.base_link, query)
                data = r = requests.get(query).text
                # data = client.parseDOM(data, 'div', attrs={'class': 'xg_module_body xg_user_generated'})[0]
                pattern = r'>season\s*%1d\s*<(.+?)(?:text-decoration|</strong></p>)' % int(season)
                data1 = re.findall(pattern, data, re.DOTALL | re.I)
                if data1:
                    links = dom_parser2.parse_dom(data1, 'a')
                    links = [i.attrs['href'] for i in links if int(episode) == int(i.content)]
                else:
                    hdlr = 'S%02dE%02d' % (int(season), int(episode))
                    links = dom_parser2.parse_dom(data, 'a')
                    links = [i.attrs['href'] for i in links if hdlr.lower() in i.attrs['href'].lower()]

                for url in links:
                    if 'youtube' in url: raise Exception()
                    quality = 'SD'
                    info = 'GR-SUB'
                    valid, host = source_utils.is_host_valid(url, hostDict)
                    if 'hdvid' in host: valid = True
                    if not valid: continue

                    sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': url, 'info': info,
                                    'direct': False, 'debridonly': False})

            else:
                query = urlparse.urljoin(self.base_link, url)
                r = requests.get(query).text
                data = client.parseDOM(r, 'div', attrs={'class': 'post-content'})
                extra = client.parseDOM(data, 'a', ret='href')
                try:
                    main = client.parseDOM(data, 'iframe', ret='src')[0]
                    if 'cloudb' in main:
                        data = client.request(main, referer=query)
                        from resources.lib.modules import jsunpack
                        unpack = jsunpack.detect(data)
                        if unpack:
                            data = jsunpack.unpack(data)
                            url = re.findall(r'sources:\["(.+?)"\]', data)[0]
                            url += '|User-Agent={}&Referer={}'.format(urllib.quote(client.agent()),
                                                                      urllib.quote(main))
                            try:
                                sub = re.findall(r'''externalTracks:\[\{src:['"](.+?)["']\,label''', data, re.DOTALL)[0]
                            except IndexError:
                                sub = ''
                            sources.append({'source': 'DL', 'quality': '720p', 'language': 'en', 'url': url, 'info': 'GR-SUB',
                                            'sub': sub, 'direct': True, 'debridonly': False})
                except BaseException:
                    pass

                for url in extra:
                    # url = i[0]['href']
                    if 'youtube' in url:
                        continue

                    quality = 'SD'
                    info = 'GR-SUB'
                    valid, host = source_utils.is_host_valid(url, hostDict)
                    if 'hdvid' in host:
                        valid = True
                    if not valid:
                        continue

                    sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': url, 'info': info,
                                    'direct': False, 'debridonly': False})

            return sources
        except BaseException:
            return sources

    def resolve(self, url):

        return url
